clearvars
close all
addpath('functions');

% define workspace size and obstacle in it
xMax = 1000;
yMax = 1000;
obstacle = [300,300,500,500];

% define RRT properties
stepSize = 30;
numNodes = 3000;
goalBias = 0.05;
searchRange = 50;
useRRTStar = 0;

% define start and goal
qStart.coord = [0 0];
qStart.cost = 0;
qStart.parent = 0;
qGoal.coord = [999 999];
qGoal.cost = 0;
qStart.parent = 0;
qNew = qStart;
nodes(1) = qStart; % add start to node list

% plot the workspace
figure(1)
axis([0 xMax 0 yMax])
rectangle('Position',obstacle,'FaceColor',[0 .5 .5])
hold on

% iterate until maximum number of nodes is reached
for i = 1:1:numNodes
    % generate random sample from sampler
    qRand = sample(xMax, yMax, qGoal, goalBias);
    
    % Pick the closest node from existing list to branch out from
    [qNearest, val] = findNearest(qRand, nodes);
    
    % Steer towards nearest node with maximum step size
    qNew.coord = steer(qRand, qNearest.coord, val, stepSize);
    
    if noCollision(qNew.coord, qNearest.coord, obstacle)
        % set initial data to qNew
        qNew.cost = dist(qNew.coord, qNearest.coord) + qNearest.cost;
        qNew.parent = qNearest;
        
        % stop if new node is at goal coordinates
        if qNew.coord == qGoal.coord 
            qGoal = qNew;
            break;
        end
        
        % shortcut algorithm, if only standard RRT is used
        if ~useRRTStar
            nodes = [nodes qNew];
            drawLine(qNearest, qNew, 'k');
            continue
        end
        
        % =========== expanded algoriht of the RRT* ===========
        
        % =========== choose parent algorithm ===========
        % possible functions to use: findNear, sortCosts, noCollision, drawLine
        
        % has to be implemented 
        % ->

        % <-
        
        % =========== rewire algorithm ===========
        % has to be implemented 
        % ->

        % <-

        nodes = [nodes qNew];
    end
end

% print path from goal to start
drawPath(qGoal, qStart);



